"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var polarToCartesian = exports.polarToCartesian = function polarToCartesian(centerX, centerY, radius, degrees) {
  var radians = degrees * Math.PI / 180.0;
  return {
    x: centerX + radius * Math.cos(radians),
    y: centerY + radius * Math.sin(radians)
  };
};

var circularArc = exports.circularArc = function circularArc(centerX, centerY, minAngle, maxAngle, r) {
  var start = polarToCartesian(centerX, centerY, r, maxAngle);
  var end = polarToCartesian(centerX, centerY, r, minAngle);
  var largeArcFlag = maxAngle - minAngle <= 180 ? 0 : 1;
  return "M " + start.x + " " + start.y + " A " + r + " " + r + " 0 " + largeArcFlag + " 0 " + end.x + " " + end.y;
};